%%
% calculus L_LPF si imponemos C_LPF (y valor suma de R_L_LPF y R_C_LPF)

clc
C = C_LPF;
R_L = R_L_LPF;
R_C = R_C_LPF;


% metod 1
% for each freq_resonance there is a C
% w_r = 50*27 * (2*pi);
w_r = 50*4.5 * (2*pi);
% w_r = 50*21.555 * (2*pi);
% no integer multiple of 50 to avoid Mp at resonance freq in an harmonic frequency
% 21 if freq_switch is 10kHz if 20kHz its 27: leer pg alpha-4.1 reverso Criterio 3.1

solveMetod = 1;
switch solveMetod
    case 1 % mtodo exacto
        % delta = sqrt((R_L + R_C)^2 * C / (4 * L));
        % w_n = 1/sqrt(L*C); % for any R_C
        % w_r = w_n * sqrt(1 - 2*delta^2); % if 0 <= delta <= sqrt(2)/2
        % = 1/sqrt(L*C) * sqrt(1 - 2 * ((R_L + R_C)^2 * C / (4 * L)) )
        
        % C, R_L, R_C
        p = [C*w_r^2, ...
            (-1) , ...
            (R_L + R_C)^2 * C / 2];
        xopt = roots(p);
        % polyval(p,L)
        
        for k = 1 : 2
            L = xopt(k);
            delta = sqrt((R_L + R_C)^2 * C / (4 * L));
            if delta < sqrt(2)/2
                valid_array(k) = 1;
            else
                valid_array(k) = 0;
                % error('base teorica no valida')
            end
        end
        if prod(valid_array) % ambas soluciones vlidas
            % solucin mas prxima una orientativa
            %     closest = 10e-3; %10mH continuo
            closest = 10e-3; %4mH discreto
            if ( abs(xopt(1) - closest) < abs(xopt(2) - closest))
                L = xopt(1);
            else
                L = xopt(2);
            end
        else
            if valid_array(1)
                L = xopt(1);
            elseif valid_array(2)
                L = xopt(2);
            else
                error('no solution')
            end
        end
        
        clear('p','xopt','k','delta','valid_array','closest');
    case 2 % mtodo aproximado
        % w_n = 1/sqrt(L*C);
        % w_r = w_n * sqrt(1 - 2*delta^2);
        % aproximo w_r = w_n
        L = 1 / ( C * w_r^2 );
        
        % compruebo que peso de sqrt(1 - 2*delta^2) es enamo
        % delta = sqrt((R_L + R_C)^2 * C / (4 * L));
        
end
L_LPF = L;

% compruebo w_r es el armnico deseado
% (1/sqrt(L*C) * sqrt(1 - 2 * ((R_L + R_C)^2 * C / (4 * L)) ))/(2*pi*50)
% (1/sqrt(L*C))/(50*2*pi)

% L,C,R_L,R_C
L_LPF,C_LPF,R_L_LPF,R_C_LPF

clear('L','C','R_L','R_C','solveMetod');
%%
if 0
R_L = R_L_LPF;
R_C = R_C_LPF;

    if exist('y'), clear y; end
    if exist('x'), clear x; end
    N = 1e4;
    x = linspace(1e-6, C_LPF*5 ,N); %capacitnacia
    for m = 1 : N
        C = x(m);
        p = [C*w_r^2, ...
            (-1) , ...
            (R_L + R_C)^2 * C / 2];
        xopt  = roots(p); % inductancia
        
        for k = 1 : 2
            L = xopt(k);
            delta = sqrt((R_L + R_C)^2 * C / (4 * L));
            if delta < sqrt(2)/2
                valid_array(k) = 1;
            else
                valid_array(k) = 0;
                % error('base teorica no valida')
            end
        end
        if prod(valid_array)
            % solucin mas prxima una orientativa
            closest = 10e-3; %10mH
            if ( abs(xopt(1) - closest) < abs(xopt(2) - closest))
                L = xopt(1);
            else
                L = xopt(2);
            end
        else
            if valid_array(1)
                L = xopt(1);
            elseif valid_array(2)
                L = xopt(2);
            else
                error('no solution')
            end
        end
        
        y(m)=L;
    end
    
    figure
    plot(x,y)
    grid on;
    ylabel('Inductancia de bobina',...
        'fontweight','normal','FontSize',36);
    xlabel('Capacidad del condensador',...
        'fontweight','normal','FontSize',36);
    
    if 1
        xlim([2.5e-5,250e-6]);
        axh = gca;
        set(axh,'XTick',50e-6*[1:1:10],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'XTickLabel',{'50\muF','100\muF','150\muF','200\muF','250\muF'},...
                'FontWeight','normal','FontSize',20)        
            set(axh,'YTick',5e-3*[1:1:5],...
            'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        set(axh,'YTickLabel',{'5mH','10mH','15mH','20mH'},...
                'FontWeight','normal','FontSize',20)
    end
    
    h = legend(...
        '$\omega_r^2\,=\,\frac{1}{L\,\cdot\,C}\left(1\,-\,2\left(\frac{\left(R_L\,+\,R_C\right)^2\,\cdot\,C}{4\,L}\right)\right)$');
    set(h,'Interpreter','latex',...
        'FontSize',20);
    %         'Color','none');
end

% % metod 2
% % for each freq_resonance there is a C
% w_n = 50*21 * (2*pi); % no integer multiple of 50 to avoid Mp at resonance freq in an harmonic frequency
% C =  1/( w_r^2 * L)

%     compruebo w_r es el armnico
% (1/sqrt(L*C) * sqrt(1 - 2 * ((R_L + R_C)^2 * C / (4 * L)) ))/(2*pi*50)

%%
% calculus C_LPF si imponemos L_LPF (y valor suma de R_L_LPF y R_C_LPF)

if 0
    clc
    L = L_LPF;
    R_L = R_L_LPF;
    R_C = R_C_LPF;
    
    
    % metod 1
    % for each freq_resonance there is a C
    w_r = 50*27 * (2*pi);
    % w_r = 50*21.555 * (2*pi);
    % no integer multiple of 50 to avoid Mp at resonance freq in an harmonic frequency
    % 21 if freq_switch is 10kHz if 20kHz its 27: leer pg alpha-4.1 reverso Criterio 3.1
    
    % delta = sqrt(R_L^2 * C / (4 * L));
    % delta = sqrt((R_L + R_C)^2 * C / (4 * L));
    % w_n = 1/sqrt(L*C); % for any R_C
    % w_r = w_n * sqrt(1 - 2*delta^2); % if 0 <= delta <= sqrt(2)/2
    % = 1/sqrt(L*C) * sqrt(1 - 2 * (R_L^2 * C / (4 * L)) )
    % = 1/sqrt(L*C) * sqrt(1 - 2 * ((R_L + R_C)^2 * C / (4 * L)) )
    
    % L, R_L, R_C
    C = 1 / (...
        L*w_r^2 + ((R_L + R_C)^2 / (2 * L))...
        );
    % % Mal:
    % % Thus:
    % % w_r^2 * C = 1/L - 1/L * 2 * ((R_L + R_C)^2 * C / (4 * L)) )
    % C = (1/L) / (w_r^2 + 1/L * 2 * ((R_L + R_C)^2 / (4 * L)) );
    
    delta = sqrt((R_L + R_C)^2 * C / (4 * L));
    if delta > sqrt(2)/2
        error('base teorica no valida')
    end
    
    
    % % metod 2
    % % for each freq_resonance there is a C
    % w_n = 50*21 * (2*pi); % no integer multiple of 50 to avoid Mp at resonance freq in an harmonic frequency
    % C =  1/( w_r^2 * L)
    
    
    C_LPF = C
    % L,C,R_L,R_C
    
    %     compruebo w_r/(2*pi*50) =
    (1/sqrt(L*C) * sqrt(1 - 2 * ((R_L + R_C)^2 * C / (4 * L)) ) ) /(2*pi*50)
end
%%
if 0
    L = L_LPF;
    R_L = R_L_LPF;
    R_C = R_C_LPF;
    C = C_LPF;
    L,C,R_L,R_C
    
    freq_switch = 25e3;
    
    w_r_desired = w_r;
    w = logspace( log10(w_r_desired) - .3 , log10(2*pi*freq_switch) + .1, 1e5 );
    figure
    bode(tf([R_C*C 1],[L*C (R_L + R_C)*C 1]),w)
    hold on
    R_C = 0;
    %     bode(tf([R_C*C 1],[L*C (R_L + R_C)*C 1]),w)
    semilogx((freq_switch*2*pi)*[1 1],[-180,0],'g')
    semilogx(w_r_desired*[1 1],[-180,0],'g')
    %     semilogx(20*50*2*pi*[1 1],[-180,0],'g')
    hold off
    grid on
    
end

%%
if 0
    L = L_LPF;
    R_L = R_L_LPF;
    R_C = R_C_LPF;
    C = C_LPF;
    
    freq_switch = 25e3;
    
    w_r_desired = w_r;
%     w = logspace( log10(w_r_desired) - .3 , log10(2*pi*freq_switch) + .1, 1e5 );
    w = logspace( log10(1e-1), log10(2*pi*freq_switch) + .1, 1e5 );
    
    [mag,fase] = bode(tf([R_C*C 1],[L*C (R_L + R_C)*C 1]),w);
    figure
    
    subplot(2,1,1)
    y = 20*log10(mag(:));
    ylim_array = 1.1 * [min(y) , max(y)];
    semilogx(w,y,'-','LineWidth',2,'Color','r')
    hold on
    semilogx((freq_switch*2*pi)*[1 1],ylim_array,'LineWidth',2,'Color','b')
    semilogx(w_r_desired*[1 1],ylim_array,'LineWidth',2,'Color','g')
    hold off
    xlim([w(1),w(end)])
    ylim(ylim_array)
    grid on
    
    subplot(2,1,2)
    semilogx(w,fase(:),'-','LineWidth',2,'Color','r')
    ylim_array =  [min(fase) - 10, max(fase) + 10];
    hold on
    semilogx((freq_switch*2*pi)*[1 1],ylim_array,'LineWidth',2,'Color','b')
    semilogx(w_r_desired*[1 1],ylim_array,'LineWidth',2,'Color','g')
    hold off
    xlim([w(1),w(end)])
    ylim(ylim_array)
    grid on
    
    
    subplot(2,1,1)
    title('Bode','fontweight','normal','fontsize',16);
    ylabel('Magnitude (dB)','fontweight','normal','FontSize',36);
    h = legend(...
        '$\left(1\,+\,R_C\,\cdot\,C\,\cdot\,s\right)\displaystyle{\frac{\frac{1}{L\,\cdot\,C}}{s^2\,+\,\frac{R_L\,+\,R_C}{L}\,\cdot\,s\,+\,\frac{1}{L\,\cdot\,C}}}$',... %tf([R_C*C 1],[L*C (R_L + R_C)*C 1]) {}
        '$f_{SW}\,=\,$ 25 kHz ($1.6\cdot 10^5$ rad/s)',...
        '$w_r$ en arm\''onico 27 ($8.7\cdot 10^3$ rad/s)');
    
    set(h,'Interpreter','latex',...
        'FontSize',20,...
        'Color','none',...
        'Box','off');
    
    subplot(2,1,2)
    ylabel('Phase (grades)','fontweight','normal','FontSize',36);
    xlabel('\omega (rad/s)','fontweight','normal','FontSize',36);
    
    L,C,R_L,R_C
end

%%
if 0
    L = L_LPF;
    R_L = R_L_LPF;
    R_C = R_C_LPF;
    C = C_LPF;
    
    freq_switch = 25e3;
    
    w_r_desired = w_r;
    w = logspace( log10(w_r_desired) - .3 , log10(2*pi*freq_switch) + .1, 1e5 );
    
    [mag,fase] = bode(tf([R_C*C 1],[L*C (R_L + R_C)*C 1]),w);
    [mag1,fase1] = bode(tf([R_C*C 1],[1]),w);
    [mag2,fase2] = bode(tf([1],[L*C (R_L + R_C)*C 1]),w);
    
    figure
    
    subplot(2,1,1)
    y = 20*log10(mag(:));
    y1 = 20*log10(mag1(:));
    y2 = 20*log10(mag2(:));
    ylim_array = 1.1 * [min(min([y,y1,y2])) , max(max([y,y1,y2]))];
    semilogx(w,y,'-','LineWidth',2,'Color','r')
    hold on
    semilogx(w,y1,'-','LineWidth',2,'Color','b')
    semilogx(w,y2,'-','LineWidth',2,'Color',[.2 .6 .4])
    hold off
    xlim([w(1),w(end)])
    ylim(ylim_array)
    grid on
    
    subplot(2,1,2)
    semilogx(w,fase(:),'-','LineWidth',2,'Color','r')
    ylim_array =  [min(min([fase,fase1,fase2])) - 10, max(max([fase,fase1,fase2])) + 10];
    hold on
    semilogx(w,fase1(:),'-','LineWidth',2,'Color','b')
    semilogx(w,fase2(:),'-','LineWidth',2,'Color',[.2 .6 .4])
    hold off
    xlim([w(1),w(end)])
    ylim(ylim_array)
    grid on
    
    
    subplot(2,1,1)
    title('Bode','fontweight','normal','fontsize',16);
    ylabel('Magnitude (dB)','fontweight','normal','FontSize',36);
    
    
    subplot(2,1,2)
    ylabel('Phase (grades)','fontweight','normal','FontSize',36);
    xlabel('\omega (rad/s)','fontweight','normal','FontSize',36);
    
    h = legend(...
        '$\left(1\,+\,R_C\,\cdot\,C\,\cdot\,s\right)\displaystyle{\frac{\frac{1}{L\,\cdot\,C}}{s^2\,+\,\frac{R_L\,+\,R_C}{L}\,\cdot\,s\,+\,\frac{1}{L\,\cdot\,C}}}$',... %tf([R_C*C 1],[L*C (R_L + R_C)*C 1]) {}
        'cero simple $1\,+\,R_C\,\cdot\,C\,\cdot\,s$',...
        'factor cuadr\''atico $\displaystyle{\frac{\frac{1}{L\,\cdot\,C}}{s^2\,+\,\frac{R_L\,+\,R_C}{L}\,\cdot\,s\,+\,\frac{1}{L\,\cdot\,C}}}$');
    
    set(h,'Interpreter','latex',...
        'FontSize',20,...
        'Color','none',...
        'Box','off');
    
    L,C,R_L,R_C
end






