% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
maxFrequency = 50e3;
% fftscope_cycles = 10;
fftscope_cycles = fix((time(end) - time(1))/20e-3);

% ScopeData_power_fftscope(1)=var_Scope_Vcc_measured;

legendStr_calculatePandQ_magandphasefft(1) = {sprintf('V net')};
legendStr_calculatePandQ_magandphasefft(2) = {sprintf('I net')};
legendStr_calculatePandQ_magandphasefft(3) = {sprintf('I inversor measured')};
legendStr_calculatePandQ_magandphasefft(4) = {sprintf('I load')};
legendStr_calculatePandQ_magandphasefft(5) = {sprintf('I C LPF')};
legendStr_calculatePandQ_magandphasefft(6) = {sprintf('I inversor reference')};

g_array = [...
    g_V_net ,...
    g_I_net ,...
    g_I_inversor_measured ,...
    g_I_load ,...
    g_I_C_LPF ,...
    g_I_inversor_reference ];
N = length(g_array);

for g = 1 : length(g_array)
    
    FFDATA = power_fftscope(ScopeData_power_fftscope(g_array(g)));
    FFDATA.cycles = fftscope_cycles;
    FFDATA.startTime = ScopeData_power_fftscope(g_array(g)).time(end) - 20e-3 * FFDATA.cycles;
    FFDATA.fundamental = 50;
    FFDATA.maxFrequency = maxFrequency;
    FFDATA = power_fftscope(FFDATA);
    
    freq_fft(:,g) = FFDATA.freq;
    mag_fft(:,g)  = FFDATA.mag / sqrt(2); %RMS ;%/ FFDATA.magFundamental*100;
    phase_fft(:,g) = FFDATA.phase * pi/180;
    if 0
        harmonic_order_array = 0 : 50*40;
        x_plot = zeros(1,length(harmonic_order_array));
        y_plot = x_plot;
        y_phase = x_plot;
        for k = 1 : length(harmonic_order_array)
            [c index] = min(abs(FFDATA.freq - 50*harmonic_order_array(k))); %index of closest value % help min
            freq_fft(k,g) = FFDATA.freq(index); %closest value
            mag_fft(k,g)  = FFDATA.mag(index) / sqrt(2); %RMS %/ FFDATA.magFundamental*100; %closest value
            
            phase_fft(k,g) = FFDATA.phase(index) * pi/180;
        end
    end
    
    x_lim = 50*40;
    
    figure(90);
    subplot(N,1,g);
    plot(freq_fft(:,g) , mag_fft(:,g));
    xlim([x_lim + 1 , freq_fft(end,g)]);
    legend(legendStr_calculatePandQ_magandphasefft(g),'Location','Best');
    if g == 1, title('RMS');end
    
    figure(92);
    subplot(N,1,g);
    bar(freq_fft(:,g) , mag_fft(:,g));
    xlim([ freq_fft(1,g) , x_lim ]);
    legend(legendStr_calculatePandQ_magandphasefft(g),'Location','Best');
    if g == 1, title('RMS');end
    
    figure(91);
    subplot(N,1,g);
    plot(freq_fft(:,g) , phase_fft(:,g));
    xlim([x_lim + 1 , freq_fft(end,g)]);
    legend(legendStr_calculatePandQ_magandphasefft(g),'Location','Best');
    if g == 1, title('phase');end
    
    figure(93);
    subplot(N,1,g);
    bar(freq_fft(:,g) , phase_fft(:,g));
    xlim([ freq_fft(1,g) , x_lim ]);
    legend(legendStr_calculatePandQ_magandphasefft(g),'Location','Best');
    if g == 1, title('phase');end
    
end

for k = 1 : 4
    aux = 90 + k - 1;
    figure(aux);
    samexaxis('xmt','on','ytac','join','yld',1);
    set(figure(aux),'units','normalized','outerposition',[0 .07 1 .93]);
end

%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% P & Q CALCULUS

legendStr_calculatePandQ_PandQ(1) = {sprintf('Potencia de la red')};
legendStr_calculatePandQ_PandQ(2) = {sprintf('Potencia del inversor')};
legendStr_calculatePandQ_PandQ(3) = {sprintf('Potencia de la carga')};
legendStr_calculatePandQ_PandQ(4) = {sprintf('Potencia de C_{LPF}')};


gap     = [0.04 0.05]; % [gap vertical,  garhorizontal ]
width_h = [0.15 0.1]; % [ outer spacings from bottom , outer spacings from top]
width_w = [0.1 0.05]; % [ outer spacings from left , outer spacings from right]
subplot = @(m,n,p) subtightplot (m, n, p, gap ,width_h ,width_w );
% clear subplot; % at end to revert subplot = @(m,n,p) subtightplot (m, n, p, gap ,width_h ,width_w );

g_array = [...
    g_I_net ,...
    g_I_inversor_measured ,...
    g_I_load ,...
    g_I_C_LPF ];
N = length(g_array);

for g = 1 : N
    
    voltage = g_V_net; % V net
    current = g_array(g); % I a net, % I inversor measured, % Ia load measured
    
    theta = (phase_fft(:,voltage) - phase_fft(:,current));
    sin_theta = sin(theta); % rads
    cos_theta = cos(theta);%sqrt(1 - (sin_theta).^2); % rads
    mag = mag_fft(:,voltage) .* mag_fft(:,current); %RMS * RMS
    
    P(: , g) = mag .* cos_theta;
    Q(: , g) = mag .* sin_theta;
    P_3F( g ) = 3 * sum(P(: , g));
    Q_3F( g ) = 3 * sum(Q(: , g));
    
    
    if 0 % armnico a 50 Hz cuanta potencia 
    if g == 1
        [c index] = min(abs(freq_fft(:,voltage) - 50));
    aux1 = mag_fft(index,voltage)
    aux2 = mag_fft(index,g_I_net) % corriente en la red --> potencia de red
    aux3 = cos((phase_fft(index,voltage) - phase_fft(index,current)))
    aux4 = aux1 * aux2 * aux3
    end
    end
    
    figure(102);
    subplot(N,1,g);
    if 1
        [c pos] = min(abs( freq_fft(:,g) - x_lim )); %index of closest value % help min
        [MAX , index] = max(abs(P(:,g)));
        y = P(index+1 : pos , g)/MAX *100;
        x = freq_fft(index+1 : pos , g) / 50;
        bar( x, y);
        xlim([ x(1) , x(end) ]);
        aux = abs (max(y) - min(y));
        ylim([ min(y) max(y)] + aux*.1*[-1 +1]);
        set(gca,'XTick',10*[1:1:1e6],...
            'fontweight','normal','FontSize',15);%cambia el grid del eje X
        if g ~= N
            set(gca,'XTicklabel',[]);
        end
        legendStr_1(g) = {sprintf('%s (%4.01f Vatios a %02.f Hz)',char(legendStr_calculatePandQ_PandQ(g)), MAX, freq_fft(index))};
        legend(legendStr_1(g),'Location','northeast','FontSize',12,'FontWeight','normal')
    else
        bar(freq_fft(:,g) , P(:,g));
        xlim([ freq_fft(1,g)  , x_lim ]);
        legend(legendStr_calculatePandQ_PandQ(g),'Location','Best');
    end
    clear('x','y');
    
    figure(100);
    subplot(N,1,g);
    if 1
        % [c pos] = min(abs( freq_fft(:,g) - x_lim )); %index of closest value % help min
        % [MAX , index] = max(abs(P(:,g)));
        y = P(pos + 1 : end , g)/MAX *100;
        x = freq_fft(pos + 1 : end , g) / 50;
        plot( x, y);
        xlim([ x(1) , x(end) ]);
        aux = abs (max(y) - min(y));
        if aux ~= 0
            ylim([ min(y) max(y)] + aux*.1*[-1 +1]);
        end
        set(gca,'XTick',250*[1:1:1e6],...
            'fontweight','normal','FontSize',15);%cambia el grid del eje X
        if g ~= N
            set(gca,'XTicklabel',[]);
        end
        % legendStr_1(g) = {sprintf('%s (%4.01f Vatios a %02.f Hz)',char(legendStr_calculatePandQ_PandQ(g)), MAX, freq_fft(index))};
        legend(legendStr_1(g),'Location','northeast','FontSize',12,'FontWeight','normal')
    else
        plot(freq_fft(:,g) , P(:,g));
        xlim([x_lim + 1 , freq_fft(end,g)]);
        legend(legendStr_calculatePandQ_PandQ(g),'Location','Best');
    end
    clear('x','y');
    
    figure(103);
    subplot(N,1,g);
    if 1
        [c pos] = min(abs( freq_fft(:,g) - x_lim )); %index of closest value % help min
        [MAX , index] = max(abs(Q(:,g)));
        y = Q(index+1 : pos , g)/MAX *100;
        x = freq_fft(index+1 : pos , g) / 50;
        bar( x, y);
        xlim([ x(1) , x(end) ]);
        aux = abs (max(y) - min(y));
        ylim([ min(y) max(y)] + aux*.1*[-1 +1]);
        set(gca,'XTick',10*[1:1:1e6],...
            'fontweight','normal','FontSize',15);%cambia el grid del eje X
        if g ~= N
            set(gca,'XTicklabel',[]);
        end
        legendStr_2(g) = {sprintf('%s (%4.01f VAr a %02.f Hz)',char(legendStr_calculatePandQ_PandQ(g)), MAX, freq_fft(index))};
        legend(legendStr_2(g),'Location','northeast','FontSize',12,'FontWeight','normal')
    else
        bar(freq_fft(:,g) , Q(:,g));
        xlim([ freq_fft(1,g)  , x_lim ]);
        legend(legendStr_calculatePandQ_PandQ(g),'Location','Best');
    end
    clear('x','y');
    
    figure(101);
    subplot(N,1,g);
    if 1
        % [c pos] = min(abs( freq_fft(:,g) - x_lim )); %index of closest value % help min
        % [MAX , index] = max(abs(Q(:,g)));
        y = Q(pos + 1 : end , g)/MAX *100;
        x = freq_fft(pos + 1 : end , g) / 50;
        plot( x, y);
        xlim([ x(1) , x(end) ]);
        aux = abs (max(y) - min(y));
        if aux ~= 0
            ylim([ min(y) max(y)] + aux*.1*[-1 +1]);
        end
        set(gca,'XTick',250*[1:1:1e6],...
            'fontweight','normal','FontSize',15);%cambia el grid del eje X
        if g ~= N
            set(gca,'XTicklabel',[]);
        end
        % legendStr_2(g) = {sprintf('%s (%4.01f VAr a %02.f Hz)',char(legendStr_calculatePandQ_PandQ(g)), MAX, freq_fft(index))};
        legend(legendStr_2(g),'Location','northeast','FontSize',12,'FontWeight','normal')
    else
        plot(freq_fft(:,g) , Q(:,g));
        xlim([x_lim + 1 , freq_fft(end,g)]);
        legend(legendStr_calculatePandQ_PandQ(g),'Location','Best');
    end
    clear('x','y');
    
    
end

if 0
    for k = 1 : 4
        aux = 100 + k - 1;
        figure(aux);
        samexaxis('join');
        set(figure(aux),'units','normalized','outerposition',[0 .07 1 .93]);
    end
end


for k = 0 : 2 :2
    aux = 100 + k;
    figure(aux);
    [ax,h1]=suplabel('Armnico');
    [ax,h2]=suplabel('Vatios (%)','y');
    [ax,h3]=suplabel('Potencia til monofsica' ,'t');
    set(h1,'FontSize',30);
    set(h2,'FontSize',30);
    set(h3,'FontSize',30);
        set(figure(aux),'units','normalized','outerposition',[0 .05 1 .92]);
end

for k = 0 : 2 :2
    aux = 100 + 1 + k;
    figure(aux);
        [ax,h1]=suplabel('Armnico');
    [ax,h2]=suplabel('VAr (%)','y');
    [ax,h3]=suplabel('Potencia reactiva monofsica' ,'t');
    set(h1,'FontSize',30);
    set(h2,'FontSize',30);
    set(h3,'FontSize',30);
    set(figure(aux),'units','normalized','outerposition',[0 .05 1 .92]);
end

P_3F'
Q_3F'

% should be zero:
sum(P_3F)
sum(Q_3F)



if 0
    x_lim = 50*40;
    
    figure;
    subplot(2,1,1);
    plot(freq_fft(:,voltage) , P(: , g));
    xlim([ freq_fft(1,voltage) , x_lim ]);
    subplot(2,1,2);
    plot(freq_fft(:,voltage) , Q(: , g))
    xlim([ freq_fft(1,voltage) , x_lim ]);
    samexaxis('xmt','on','ytac','join','yld',1);
    
    figure;
    subplot(2,1,1);
    plot(freq_fft(:,voltage) , P(: , g));
    xlim([x_lim + 1 , freq_fft(end,voltage)]);
    subplot(2,1,2);
    plot(freq_fft(:,voltage) , Q(: , g))
    xlim([x_lim + 1 , freq_fft(end,voltage)]);
    samexaxis('xmt','on','ytac','join','yld',1);
end


clear subplot; % at end to revert subplot = @(m,n,p) subtightplot (m, n, p, gap ,width_h ,width_w );

