
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot Vcc

figure('units','normalized','outerposition',[0 .07 1 .93]);
plot(time_Vcc, Vcc);
% legend('alfa','beta');
axh = gca;
set(axh,'XTick',[1:round(time(end))],...
    'fontweight','normal','FontSize',20);%cambia el grid del eje X
set(axh,'YTick',[0:100:1e3],...
    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
ylabel('Voltios',...
    'fontweight','normal','FontSize',36);
xlabel('Segundos',...
    'fontweight','normal','FontSize',36);
title(sprintf('Tensin del condensador de continua'),...
    'fontweight','normal','FontSize',36);
grid on;
legend('Vcc measured');

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot currents_inversor & net

time_plot = 25e-3;
if time(end) <= time_plot
    Xlim = [0,time(end)];
else
    Xlim = [time(end) - time_plot,time(end)];
end

if exist('legendStr'), clear legendStr; end
legendStr(1) = {sprintf('Ia net')};
legendStr(2) = {sprintf('Ia load')};
legendStr(3) = {sprintf('Iu inversor measured')};
if simulacionContinua1Discreta2RTmanager3 ~= 3
legendStr(4) = {sprintf('Iu inversor reference')};
end

figure('units','normalized','outerposition',[0 .07 1 .93]);
plot(time, ScopeData_power_fftscope(g_I_net).signals(1).values,'g');
hold on;
plot(time, ScopeData_power_fftscope(g_I_load).signals(1).values,'b');
plot(time, ScopeData_power_fftscope(g_I_inversor_measured).signals(1).values,'r');
if simulacionContinua1Discreta2RTmanager3 ~= 3
plot(time, ScopeData_power_fftscope(g_I_inversor_reference).signals(1).values,'k');
end
hold off;
xlim(Xlim);
axh = gca;
if 1
    switch simulacionContinua1Discreta2RTmanager3
        case 1 %simulacin continua en Matlab
            set(axh,'XTick',[0:1e-2:round(time(end))],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[-30:15:30],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 2 %simulacin discretra en Matlab
            set(axh,'XTick',[0:1e-2:round(time(end))],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[-30:15:30],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 3 %simulacin RTmanager
            set(axh,'XTick',(time(end)-time(1))/4*[0:1:1e3],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[-30:15:30],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        otherwise
            disp('error simulacionContinua0Discreta1RTmanager2')
    end
    ylabel('Amperios',...
        'fontweight','normal','FontSize',36);
    xlabel('Segundos',...
        'fontweight','normal','FontSize',36);
    title(sprintf(''),...
        'fontweight','normal','FontSize',36);
    grid on;
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',20,'FontWeight','normal')
end



%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot voltage neutro y punto medio de fuente del inversor

time_plot = 25e-3;
if time(end) <= time_plot
    Xlim = [0,time(end)];
else
    Xlim = [time(end) - time_plot,time(end)];
end


figure('units','normalized','outerposition',[0 .07 1 .93]);

subplot(2,1,1);
if exist('legendStr'), clear legendStr; end
legendStr(1) = {sprintf('V net phase')};
if simulacionContinua1Discreta2RTmanager3 ~= 3
legendStr(2) = {sprintf('V MN')};
legendStr(3) = {sprintf('V inverter phase')};
end



plot(time_V_UN_V_MN_V_RN, V_net_phase,'g');
hold on;
if simulacionContinua1Discreta2RTmanager3 ~= 3
plot(time_V_UN_V_MN_V_RN, V_MN,'b');
plot(time_V_UN_V_MN_V_RN, V_inverter_phase,'r');
end
hold off;
xlim(Xlim);
axh = gca;
if 1
    if 0
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                set(axh,'XTick',[0:1e-2:round(time_V_UN_V_MN_V_RN(end))],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',325*[-1:1:1],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:1e-2:round(time_V_UN_V_MN_V_RN(end))],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',325*[-1:1:1],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    ylim(700*[ -1 , 1 ]);
    ylabel('Voltios',...
        'fontweight','normal','FontSize',36);
    xlabel('Segundos',...
        'fontweight','normal','FontSize',36);
    title(sprintf(''),...
        'fontweight','normal','FontSize',36);
    grid on;
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',10,'FontWeight','normal')
end

subplot(2,1,2);
if exist('legendStr'), clear legendStr; end
legendStr(1) = {sprintf('Ia net')};
legendStr(2) = {sprintf('Ia load')};
legendStr(3) = {sprintf('Iu inversor measured')};
if simulacionContinua1Discreta2RTmanager3 ~= 3
legendStr(4) = {sprintf('Iu inversor reference')};
end

plot(time, ScopeData_power_fftscope(g_I_net).signals(1).values,'g');
hold on;
plot(time, ScopeData_power_fftscope(g_I_load).signals(1).values,'b');
plot(time, ScopeData_power_fftscope(g_I_inversor_measured).signals(1).values,'r');
if simulacionContinua1Discreta2RTmanager3 ~= 3
plot(time, ScopeData_power_fftscope(g_I_inversor_reference).signals(1).values,'k');
end
hold off;
xlim(Xlim);
axh = gca;
if 1
    if 0
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                set(axh,'XTick',[0:1e-2:round(time(end))],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',[-30:15:30],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:1e-2:round(time(end))],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',[-30:15:30],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    ylim(30*[ -1 , 1 ]);
    ylabel('Amperios',...
        'fontweight','normal','FontSize',36);
    xlabel('Segundos',...
        'fontweight','normal','FontSize',36);
    title(sprintf(''),...
        'fontweight','normal','FontSize',36);
    grid on;
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',10,'FontWeight','normal')
end

% "parseArgs" and "samexaxis" are functions downlaoded in:
addpath 'C:\Users\media\Documents\MEGAsync\Matlab_Mathematica_LaTeX\MATLAB\MATLAB_trabajos\functions';
samexaxis('abc','xmt','on','ytac','join','yld',1);

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot current neutro y punto medio de fuente del inversor

y = V_MN / R_neutro_inverter_C_LPF;

if exist('legendStr'), clear legendStr; end
legendStr(1) = {sprintf('I MN')};

figure('units','normalized','outerposition',[0 .07 1 .93]);
plot(time, y );
axh = gca;
if 1
    if 0
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                set(axh,'XTick',[0:1e-2:round(time(end))],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',[-30:15:30],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:1e-2:round(time(end))],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',[-30:15:30],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    if min(y) < max(y)
        ylim(1.1*[ min(y) , max(y) ]);
    end
    ylabel('Amperios',...
        'fontweight','normal','FontSize',36);
    xlabel('Segundos',...
        'fontweight','normal','FontSize',36);
    title(sprintf(''),...
        'fontweight','normal','FontSize',36);
    grid on;
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',10,'FontWeight','normal')
end


% y su FFT

if exist('legendStr'), clear legendStr; end
legendStr(1) = {sprintf('I MN')};

aux_power_fftscope.time =  time;
aux_power_fftscope.signals(1).values =  y;
aux_power_fftscope.blockName = 'data2FFT';


FFDATA = power_fftscope(aux_power_fftscope);
maxFrequency = 50*600;
harmonic_order_array = 0 : (maxFrequency/50);
filtroactivo_resaults_fft_general_aux01;

% harmonic_0_phase_Vnet =  y_phase(2);
% harmonic_0 =  y_plot(1) / sqrt(2);
% harmonic_1 =  y_plot(2) / sqrt(2);
% x_plot = x_plot(3:end);
% y_plot = y_plot(3:end);

% y_plot = y_plot/ FFDATA.magFundamental*100; % peak in porcentage

freq_I_MN = x_plot;
mag_I_MN = y_plot;

aux = min(length(freq_I_MN) , 40);
figure('units','normalized','outerposition',[0 .07 1 .93]);
subplot(2,1,1);
bar(freq_I_MN(1:aux) , mag_I_MN(1:aux));
xlim([1-.5 , aux+.5]);
hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
set(hleg,'FontSize',10,'FontWeight','normal');
axh = gca;
set(axh,'XTick',3*[0:1:aux],...
    'fontweight','normal','FontSize',20);%cambia el grid del eje X
subplot(2,1,2);
bar(freq_I_MN(aux:end) , mag_I_MN(aux:end));
xlim([aux-.5, length(freq_I_MN)+.5]);
hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
set(hleg,'FontSize',10,'FontWeight','normal')


%%
% V net %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FFDATA = power_fftscope(ScopeData_power_fftscope(g_V_net));
maxFrequency = 50*600;
harmonic_order_array = 0 : (maxFrequency/50);
filtroactivo_resaults_fft_general_aux01;

mag_Vnet = y_plot;
phase_Vnet = y_phase;

harmonic_0_phase_Vnet =  y_phase(2);
harmonic_0 =  y_plot(1) / sqrt(2);
harmonic_1 =  y_plot(2) / sqrt(2);
x_plot = x_plot(3:end);
y_plot = y_plot(3:end);

y_plot = y_plot/ FFDATA.magFundamental*100; % peak in porcentage

figure('units','normalized','outerposition',[0 .07 1 .93]);
bar(x_plot , y_plot);
xlim([2-.5,max(x_plot)+.5]);
ylim([0, max(y_plot)]);

if 1
    axh = gca;
    switch simulacionContinua1Discreta2RTmanager3
        case 1 %simulacin continua en Matlab
            set(axh,'XTick',100*[0:1:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[0:.1:.2],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 2 %simulacin discretra en Matlab
            set(axh,'XTick',100*[0:1:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',5e-4*[0:1:1e2],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 3 %simulacin RTmanager
            set(axh,'XTick',100*[0:1:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',5e-3*[0:1:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        otherwise
            disp('error simulacionContinua0Discreta1RTmanager2')
    end
end
ylabel('Voltios de RMS (%)',...
    'fontweight','normal','FontSize',36);
xlabel('Armnico',...
    'fontweight','normal','FontSize',36);
title(sprintf('armnico 0 de %1.02e Voltios RMS\narmnico 1 de %2.02f Voltios RMS',harmonic_0,harmonic_1),...
    'fontweight','normal','FontSize',36);
grid on;
legend('V net 3F');

%%
% I net %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FFDATA = power_fftscope(ScopeData_power_fftscope(g_I_net));
maxFrequency = 50*600;
harmonic_order_array = 0 : (maxFrequency/50);
filtroactivo_resaults_fft_general_aux01;

mag_Inet = y_plot;
phase_Inet = y_phase;

harmonic_0_phase_Vnet =  y_phase(2);
harmonic_0 =  y_plot(1) / sqrt(2);
harmonic_1 =  y_plot(2) / sqrt(2);
x_plot = x_plot(3:end);
y_plot = y_plot(3:end);

y_plot = y_plot/ FFDATA.magFundamental*100; % peak in porcentage

figure('units','normalized','outerposition',[0 .07 1 .93]);
bar(x_plot , y_plot);
xlim([2-.5,max(x_plot)+.5]);
ylim([0, max(y_plot)]);
grid on;

if 1
    axh = gca;
    switch simulacionContinua1Discreta2RTmanager3
        case 1 %simulacin continua en Matlab
            set(axh,'XTick',100*[0:1:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[0:.5:2],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 2 %simulacin discretra en Matlab
            set(axh,'XTick',[100:100:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',5e-2*[0:1:1e2],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 3 %simulacin RTmanager
            set(axh,'XTick',[100:100:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',1e-1*[0:1:1e2],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        otherwise
            disp('error simulacionContinua0Discreta1RTmanager2')
    end
    ylabel('Amperios (%)',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('armnico 0 de %1.02e Amperios RMS\narmnico 1 de %2.02f Amperios RMS',harmonic_0,harmonic_1),...
        'fontweight','normal','FontSize',36);
    grid on;
    legend('I net');
end




%%
% I inversor measured %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FFDATA = power_fftscope(ScopeData_power_fftscope(g_I_inversor_measured));
maxFrequency = 50*600;
harmonic_order_array = 0 : (maxFrequency/50);
filtroactivo_resaults_fft_general_aux01;

mag_Iinversor = y_plot;
phase_Iinversor = y_phase;

harmonic_0_phase_Vnet =  y_phase(2);
harmonic_0 =  y_plot(1) / sqrt(2);
harmonic_1 =  y_plot(2) / sqrt(2);
x_plot = x_plot(3:end);
y_plot = y_plot(3:end);

% y_plot = y_plot/ FFDATA.magFundamental*100; % peak in porcentage
y_plot = y_plot/ sqrt(2); %RMS

figure('units','normalized','outerposition',[0 .07 1 .93]);
bar(x_plot , y_plot);
xlim([2-.5,40+.5]);
if max(y_plot) > 0,     ylim([0, 1.1*max(y_plot)]);     end
grid on;
axh = gca;
if 1
    switch simulacionContinua1Discreta2RTmanager3
        case 1 %simulacin continua en Matlab
            %         set(axh,'XTick',[0:100:x_plot(end)],...
            %             'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'XTick',[0:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[0:1:2.5],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 2 %simulacin discretra en Matlab
            %         set(axh,'XTick',[0:100:x_plot(end)],...
            %             'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'XTick',[0:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[0:1:2.5],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 3 %simulacin RTmanager
            set(axh,'XTick',[0:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',5*[0:1:1e6],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        otherwise
            disp('error simulacionContinua0Discreta1RTmanager2')
    end
    ylabel('Amperios RMS',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('armnico 0 de %1.02e Amperios RMS\narmnico 1 de %2.02f Amperios RMS',harmonic_0,harmonic_1),...
        'fontweight','normal','FontSize',36);
    grid on;
    legend('I inversor measured');
end


%%
% I inversor reference %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FFDATA = power_fftscope(ScopeData_power_fftscope(g_I_inversor_reference ));
FFDATA = power_fftscope(ScopeData_power_fftscope(g_I_inversor_reference));
maxFrequency = 50*600;
harmonic_order_array = 0 : (maxFrequency/50);
filtroactivo_resaults_fft_general_aux01;

% mag_Iinversor_reference = y_plot;
% phase_Iinversor_reference = y_phase;

harmonic_0_phase_Vnet =  y_phase(2);
harmonic_0 =  y_plot(1) / sqrt(2);
harmonic_1 =  y_plot(2) / sqrt(2);
x_plot = x_plot(3:end);
y_plot = y_plot(3:end);

% y_plot = y_plot/ FFDATA.magFundamental*100; % peak in porcentage
y_plot = y_plot/ sqrt(2); %RMS

figure('units','normalized','outerposition',[0 .07 1 .93]);
bar(x_plot , y_plot);
xlim([2-.5,40+.5]);
if max(y_plot) > 0,     ylim([0, 1.1*max(y_plot)]);     end
grid on;
axh = gca;
if 1
    switch simulacionContinua1Discreta2RTmanager3
        case 1 %simulacin continua en Matlab
            set(axh,'XTick',[0:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[0:1:2.5],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 2 %simulacin discretra en Matlab
            set(axh,'XTick',[0:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',[0:1:2.5],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 3 %simulacin RTmanager
            set(axh,'XTick',[0:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            % set(axh,'YTick',[0:1:2.5],...
            %    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        otherwise
            disp('error simulacionContinua0Discreta1RTmanager2')
    end
    ylabel('Amperios RMS',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('armnico 0 de %1.02e Amperios RMS\narmnico 1 de %2.02f Amperios RMS',harmonic_0,harmonic_1),...
        'fontweight','normal','FontSize',36);
    legend('I inversor reference');
end


%%
% Ia_load measured %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FFDATA = power_fftscope(ScopeData_power_fftscope(g_I_load));
maxFrequency = 50*600;
harmonic_order_array = 0 : (maxFrequency/50);
filtroactivo_resaults_fft_general_aux01;

mag_Iload = y_plot;
phase_Iload = y_phase;

harmonic_0_phase_Vnet =  y_phase(2);
harmonic_0 =  y_plot(1) / sqrt(2);
harmonic_1 =  y_plot(2) / sqrt(2);
x_plot = x_plot(3:end);
y_plot = y_plot(3:end);

y_plot = y_plot/ FFDATA.magFundamental*100; % peak in porcentage

figure('units','normalized','outerposition',[0 .07 1 .93]);
bar(x_plot , y_plot);
xlim([2-.5,40+.5]);
if max(y_plot) > 0,     ylim([0, 1.1*max(y_plot)]);     end
axh = gca;
if 1
    switch simulacionContinua1Discreta2RTmanager3
        case 1 %simulacin continua en Matlab
            set(axh,'XTick',[10:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',5*[0:1:3],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 2 %simulacin discretra en Matlab
            set(axh,'XTick',[10:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',5*[0:1:3],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        case 3 %simulacin RTmanager
            set(axh,'XTick',[10:10:40],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje X
            set(axh,'YTick',5*[0:1:3],...
                'fontweight','normal','FontSize',20);%cambia el grid del eje Y
        otherwise
            disp('error simulacionContinua0Discreta1RTmanager2')
    end
    ylabel('Amperios (%)',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('armnico 0 de %1.02e Amperios RMS\narmnico 1 de %2.02f Amperios RMS',harmonic_0,harmonic_1),...
        'fontweight','normal','FontSize',36);
    legend('I load');
end
