%% fft Inet

FFDATA = power_fftscope(ScopeData_power_fftscope(g_I_net));

maxFrequency = 41*50;
harmonic_order_array = 2 : 40;
filtroactivo_resaults_fft_general_aux01;

Inet_harmonic_freq = x_plot;
Inet_harmonic_peak = y_plot; % peak values
Inet_magFundamental = FFDATA.magFundamental; % peak values
% figure('units','normalized','outerposition',[0 .07 1 .93]); bar( Inet_harmonic_freq , Inet_harmonic_peak)

%% fft Vnet

FFDATA = power_fftscope(ScopeData_power_fftscope(g_V_net));

maxFrequency = 41*50;
harmonic_order_array = 2 : 40;

filtroactivo_resaults_fft_general_aux01;

Vnet_harmonic_freq = x_plot;
Vnet_harmonic_peak = y_plot; % peak values
Vnet_magFundamental = FFDATA.magFundamental; % peak values
% figure('units','normalized','outerposition',[0 .07 1 .93]); bar( Vnet_harmonic_freq , IVnet_harmonic_peak)


%%
Iload_peak_string = '';
for k = 1 : length(Iload_peak)
    if k == 1
        aux = Iload_peak(k); % amperes
    else
        aux = Iload_peak(k)/Iload_peak(1)*100; % in percentage
    end
    Iload_peak_string = [Iload_peak_string, '_' , num2str(aux,'%02.0f')];
end


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if IEC_1000_3_2
    % IEC_1000_3_2_Table01 IECclassA
    IECclassA = zeros(1,40);%[1.08 2.3 .43 1.14 .3 .77 .23 .4 .23*8/10 .33 .23*8/12 .21 .23*8/14 .15 .23*8/16 .15*15/17 .23*8/18 .15*15/19 .23*8/20];
    IECclassA(3:2:13) = [2.3 1.4 .77 .4 .33 .21]; IECclassA(2:2:6) = [1.08 .43 .3]; for k=15:2:39,IECclassA(k) = .15*8/k; end; for k=8:2:40,IECclassA(k) = .23*8/k; end; IECclassA(1) = [];
end

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if IEC_1000_3_4
    
    % IEC_1000_3_4_Table01
    
    % Rated apparent power (S_equ): calculated from the rated r.m.s. line current
    % I_equ of the piece of equipment and the rated voltage Up(single phase) or Ui(interphase).
    % For balanced three-phase equipment: S_equ = sqrt(3) * Ui * I_equ;
    Ui    = 400; %
    I_equ = 16; % RMS % line current  aququiere decir de cada linea, o sea, de fase
    S_equ = sqrt(3) * Ui * I_equ;
    
    % Short-circuit power (S_SC): calculated from the nominal system voltage U_nom and
    % the impedance Z at the PCC
    load('inputsSimulation.mat','L_grid');
    load('inputsSimulation.mat','R_grid');
    Z = abs(sqrt( R_grid^2 + (2*pi*50 * L_grid )^2 ));
    load('inputsSimulation.mat','Vnet_peak'); % voltage phase-phase RMS net
    U_nom    = Vnet_peak(1)  / sqrt(2); % RMS = peak / sqrt(2)
    S_SC = U_nom^2 / Z;
    
    % Short-circuit ratio (R_SCE):
    % For all three-phase equipment:  R_SCE = S_SC / S_equ
    R_SCE = S_SC / S_equ
    
    
    % R_SCE_min = 66;
    % IEC_1000_3_4_Table01 = [17 22 12 10 9 6];
    
    R_SCE_min = 600;
    IEC_1000_3_4_Table01 = [70 57 60 40 25 18];
    
    IEC_1000_3_4_Table01_XTickLabel = {'THD' 'PWHD' 'I_5 (%)' 'I_7 (%)' 'I_{11} (%)' 'I_{13} (%)'};
    
    
    aux = [2:40] - (harmonic_order_array(1) - 1);
    THD = sqrt(  sum( (Inet_harmonic_peak(aux) / Inet_magFundamental).^2 ) );
    
    aux = [14:40] - (harmonic_order_array(1) - 1);
    PWHD = sqrt(  aux* ( (Inet_harmonic_peak(aux) / Inet_magFundamental).^2 )' );
    
    I_1 = (16*sqrt(2));%= rated fundamental current
    aux = [5,7,11,13] - (harmonic_order_array(1) - 1);
    aux = Inet_harmonic_peak(aux) / I_1 * 100;
    IEC_1000_3_4_Table01_measured = [THD PWHD aux];
    
    
    % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % IEC_1000_3_4_Table02
    
    % Sliding_3.pdf
    % La tabla A.2-2 muestra los lmites para toda la instalacin segn IEC 1000-3-4. Aunque
    % los valores de THD y PWHD no se listan en la tabla, ellos se limitan al 20 % para toda la
    % instalacin. Si las tres fases no estn equilibradas, cada fase debe cumplir con la normade
    % manera individual.
    
    first_even = 1; % 1st element is 2 harmonic, 2nd is 3, ....
    first_odd  = 2;
    last_odd   = 33;
    last_even   = 40;
    
    IEC_1000_3_4_Table02 = zeros(1,length(2:40));
    IEC_1000_3_4_Table02_measured = IEC_1000_3_4_Table02;
    
    aux = [ 19 9.5 6.5 3.8 3.1 2 .7 1.2 1.1 .6 .9 .8 .6 .7 .7 .6];
    index = first_odd + 0:2:last_odd;
    IEC_1000_3_4_Table02(index) = aux;
    IEC_1000_3_4_Table02_measured(index) = Inet_harmonic_peak(index);
    aux = 2:2:40;
    aux = 4./aux;
    index = first_even + 0:2:(last_even-first_even);
    IEC_1000_3_4_Table02(index) = aux;
    IEC_1000_3_4_Table02_measured(index) = Inet_harmonic_peak(index);
    
    IEC_1000_3_4_Table02_measured = IEC_1000_3_4_Table02_measured / Inet_magFundamental * 100;
end

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if IEC_1000_2_2
    % IEC_1000_2_2_Table01
    first_harmonic = 2;
    last_harmonic = 40;
    
    IEC_1000_2_2_Table01 = zeros(1,length(first_harmonic : last_harmonic));
    IEC_1000_2_2_Table01_measured = IEC_1000_2_2_Table01;
    
    index = [ 5 7 11 13 17 19 23 25] - (first_harmonic - 1); % impares no mliplos de 3: 6 * n + - 1 hasta 25 armnico
    aux = [ 6 5 3.5 3 2 1.5 1.5 1.5 ];
    IEC_1000_2_2_Table01(index) = aux;
    IEC_1000_2_2_Table01_measured(index) = Vnet_harmonic_peak(index);
    
    index = [ 29 31 35 37 ] - (first_harmonic - 1); % impares no mliplos de 3: 6 * n + - 1 desde 29 armnico
    aux = 0.2 + 0.5 * 25 ./ index;
    IEC_1000_2_2_Table01(index) = aux;
    IEC_1000_2_2_Table01_measured(index) = Vnet_harmonic_peak(index);
    
    index = [ 3 : 6 : 21 ] - (first_harmonic - 1); % impares mliplos de 3 hasta 21
    aux = [ 5 1.5 .3 .2 ];
    IEC_1000_2_2_Table01(index) = aux;
    IEC_1000_2_2_Table01_measured(index) = Vnet_harmonic_peak(index);
    
    index = [ 27 : 6 : last_harmonic ] - (first_harmonic - 1); % impares mliplos de 3 desde 24
    aux = .2;
    IEC_1000_2_2_Table01(index) = aux;
    IEC_1000_2_2_Table01_measured(index) = Vnet_harmonic_peak(index);
    
    index = [ 2 : 2 : 12 ]  - (first_harmonic - 1); % pares hasta 12
    aux = [ 2 1 .5 .5 .5 .2 ];
    IEC_1000_2_2_Table01(index) = aux;
    IEC_1000_2_2_Table01_measured(index) = Vnet_harmonic_peak(index);
    
    index = [ 14 : 2 : last_harmonic ]   - (first_harmonic - 1); % pares desde 12
    aux = .2;
    IEC_1000_2_2_Table01(index) = aux;
    IEC_1000_2_2_Table01_measured(index) = Vnet_harmonic_peak(index);
    
    IEC_1000_2_2_Table01_measured = IEC_1000_2_2_Table01_measured / Vnet_magFundamental * 100;
end

%% IEC_1000_3_2_Table01

if IEC_1000_3_2
    
    
    y = Inet_harmonic_peak / sqrt(2); % RMS of harmonics
    
    figure('units','normalized','outerposition',[0 .07 1 .93]);
    bar(Inet_harmonic_freq ,  IECclassA, 1, 'r'); % bar width between 0 and 1 (here 1)
    hold on;
    bar(Inet_harmonic_freq , y);
    hold off;
    % text(Inet_harmonic_freq , Inet_harmonic_peak, num2str(Inet_harmonic_peak','%04.02e'),...% '%0.02f' importante: 'y' ha de ser vector columna, sino el text sale mal
    %     'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    % text(Inet_harmonic_freq , y_plot_IECclass , num2str(y_plot_IECclass','%04.02e'),...%importante: 'y' ha de ser vector columna, sino el text sale mal
    %     'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    xlim(Inet_harmonic_freq([1,end])+.5*[-1 , +1]);
    ylim([0, max(y)*1.1]);
    
    if 1
        axh = gca;
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',2.5e-3*[0:1:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',[0:.025:1],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
                
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    ylabel('Amperios RMS',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('Iload_{peak} is %s',strrep(Iload_peak_string,'_',' ')),...
        'fontweight','normal','FontSize',36);
    grid on;
    legendStr(1) = {sprintf('Lmite normativo')};
    legendStr(2) = {sprintf('Corriente de la red')};
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',20,'FontWeight','normal')
    
    % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % porcentaje de IEC_1000_3_2_Table01
    
    y = (Inet_harmonic_peak / sqrt(2)) ./ IECclassA * 100;
    
    figure('units','normalized','outerposition',[0 .07 1 .93]);
    bar(Inet_harmonic_freq , y , 1); % bar width between 0 and 1 (here 1)
    % text(Inet_harmonic_freq , Inet_harmonic_peak, num2str(Inet_harmonic_peak','%04.02e'),...% '%0.02f' importante: 'y' ha de ser vector columna, sino el text sale mal
    %     'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    % text(Inet_harmonic_freq , y_plot_IECclass , num2str(y_plot_IECclass','%04.02e'),...%importante: 'y' ha de ser vector columna, sino el text sale mal
    %     'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    xlim(Inet_harmonic_freq([1,end])+.5*[-1 , +1]);
    ylim([0, max(y)*1.1]);
    
    if 1
        axh = gca;
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                set(axh,'XTick',10*[0:1:20],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',5*[0:1:20],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',10*[0:1:20],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',10*[0:1:20],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    ylabel('Amperios (%)',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('Iload_{peak} is %s',strrep(Iload_peak_string,'_',' ')),...
        'fontweight','normal','FontSize',36);
    grid on;
end


%% IEC_1000_3_4_Table01

if IEC_1000_3_4
    figure('units','normalized','outerposition',[0 .07 1 .93]);
    bar(IEC_1000_3_4_Table01, 1, 'r'); % bar width between 0 and 1 (here 1)
    hold on;
    bar(IEC_1000_3_4_Table01_measured);
    hold off;
    % text(1:length(IEC_1000_3_4_Table01) , IEC_1000_3_4_Table01_measured, num2str(IEC_1000_3_4_Table01_measured','%04.02e'),...% '%0.02f' importante: 'y' ha de ser vector columna, sino el text sale mal
    %     'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    xlim(([1,length(IEC_1000_3_4_Table01_measured)])+.5*[-1 , +1]);
    % ylim([0, max(IEC_1000_3_4_Table01_measured)*1.1]);
    
    if 1
        axh = gca;
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                
            case 2 %simulacin discretra en Matlab
                %     set(axh,'XTick',10*[0:1:5],...
                %         'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',25*[0:1:5],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
                set(axh,'XTickLabel',IEC_1000_3_4_Table01_XTickLabel,...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    
    % ylabel('Amperios',...
    %     'fontweight','normal','FontSize',36);
    % xlabel('Armnico',...
    %     'fontweight','normal','FontSize',36);
    title(sprintf('Iload_{peak} is %s',strrep(Iload_peak_string,'_',' ')),...
        'fontweight','normal','FontSize',36);
    % grid on;
    legendStr(1) = {sprintf('Lmite normativo')};
    legendStr(2) = {sprintf('Corriente del compensador')};
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',20,'FontWeight','normal')
    
    % porcentaje de IEC_1000_3_4_Table01
    
    %  no hay ya q IEC_1000_3_4_Table01 es en porcentaje todo
end

%% IEC_1000_3_4_Table02

if IEC_1000_3_4
    
    figure('units','normalized','outerposition',[0 .07 1 .93]);
    bar(Inet_harmonic_freq ,  IEC_1000_3_4_Table02, 1); % bar width between 0 and 1 (here 1)
    hold on;
    bar(Inet_harmonic_freq , IEC_1000_3_4_Table02_measured);
    hold off;
    % text(Inet_harmonic_freq , Inet_harmonic_peak, num2str(Inet_harmonic_peak','%04.02e'),...% '%0.02f' importante: 'y' ha de ser vector columna, sino el text sale mal
    %     'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    % text(Inet_harmonic_freq , y_plot_IECclass , num2str(y_plot_IECclass','%04.02e'),...%importante: 'y' ha de ser vector columna, sino el text sale mal
    %     'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    xlim(Inet_harmonic_freq([1,end])+.5*[-1 , +1]);
    ylim([0, max(IEC_1000_3_4_Table02_measured)*1.1]);
    
    if 1
        axh = gca;
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',[0:.025:1],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    
    ylabel('Amperios (%)',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('Iload_{peak} is %s',strrep(Iload_peak_string,'_',' ')),...
        'fontweight','normal','FontSize',36);
    grid on;
    legendStr(1) = {sprintf('Lmite normativo')};
    legendStr(2) = {sprintf('Corriente de la red')};
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',20,'FontWeight','normal')
    
end

%% IEC_1000_2_2_Table01

if IEC_1000_2_2
    
    figure('units','normalized','outerposition',[0 .07 1 .93]);
    bar(Vnet_harmonic_freq ,  IEC_1000_2_2_Table01, 1, 'r'); % bar width between 0 and 1 (here 1)
    hold on;
    bar(Vnet_harmonic_freq , IEC_1000_2_2_Table01_measured);
    hold off;
    xlim(Vnet_harmonic_freq([1,end])+.5*[-1 , +1]);
    % ylim([0, max(Vnet_harmonic_peak)*1.1]);
    
    if 1
        axh = gca;
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',2*[0:1:10],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',2*[0:1:10],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    
    ylabel('Voltios (%)',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('Iload_{peak} is %s',strrep(Iload_peak_string,'_',' ')),...
        'fontweight','normal','FontSize',36);
    grid on;
    legendStr(1) = {sprintf('Lmite normativo')};
    legendStr(2) = {sprintf('Tensin de la red')};
    hleg=legend(legendStr,'Location','Best'); % 'Location','northeastoutside'
    set(hleg,'FontSize',20,'FontWeight','normal')
    
    % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % porcentaje del porcentaje
    
    y = IEC_1000_2_2_Table01_measured ./ IEC_1000_2_2_Table01 * 100;
    
    figure('units','normalized','outerposition',[0 .07 1 .93]);
    bar(Vnet_harmonic_freq , y , 1); % bar width between 0 and 1 (here 1)
    xlim(Vnet_harmonic_freq([1,end])+.5*[-1 , +1]);
    % ylim([0, max(Vnet_harmonic_peak)*1.1]);
    
    if 1
        axh = gca;
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',.1e-1*[0:1:10],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',.2e-1*[0:1:10],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    ylabel('Voltios (%)',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
    title(sprintf('Iload_{peak} is %s',strrep(Iload_peak_string,'_',' ')),...
        'fontweight','normal','FontSize',36);
    grid on;
    
end

%%

if 0
    Inet_harmonic_freq = 2:40;
    
    % IEC61000-3-2 http://www.teseq.cn/pdfinfo/05_AN_IEC61000-3-25.pdf
    IECclassA = zeros(1,40);%[1.08 2.3 .43 1.14 .3 .77 .23 .4 .23*8/10 .33 .23*8/12 .21 .23*8/14 .15 .23*8/16 .15*15/17 .23*8/18 .15*15/19 .23*8/20];
    IECclassA(3:2:13) = [2.3 1.4 .77 .4 .33 .21]; IECclassA(2:2:6) = [1.08 .43 .3]; for k=15:2:39,IECclassA(k) = .15*8/k; end; for k=8:2:40,IECclassA(k) = .23*8/k; end; IECclassA(1) = [];
    
    x_text = (3-1):2:(13+1);
    y_text = IECclassA(x_text);
    
    
    y_plot_IECclass = IECclassA;
    figure('units','normalized','outerposition',[0 .07 1 .93]); bar(Inet_harmonic_freq ,  y_plot_IECclass, 1, 'r' ); % bar width between 0 and 1 (here 1)
    %     text(Inet_harmonic_freq , y_plot_IECclass , num2str(y_plot_IECclass','%4.2f'),...%importante: 'y' ha de ser vector columna, sino el text sale mal
    %         'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    text(x_text+1 , y_text , num2str(y_text','%4.2f'),...%importante: 'y' ha de ser vector columna, sino el text sale mal
        'HorizontalAlignment','center', 'VerticalAlignment','bottom', 'FontWeight' ,'normal')
    xlim([Inet_harmonic_freq(1)-.5,Inet_harmonic_freq(end)+.5]); ylim([0, max(y_plot_IECclass)*1.1]);  grid on
    
    if 1
        axh = gca;
        switch simulacionContinua1Discreta2RTmanager3
            case 1 %simulacin continua en Matlab
                
            case 2 %simulacin discretra en Matlab
                set(axh,'XTick',[0:10:40],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje X
                set(axh,'YTick',1*[0:1:10],...
                    'fontweight','normal','FontSize',20);%cambia el grid del eje Y
            case 3 %simulacin RTmanager
                
            otherwise
                disp('error simulacionContinua0Discreta1RTmanager2')
        end
    end
    
    ylabel('Amperios',...
        'fontweight','normal','FontSize',36);
    xlabel('Armnico',...
        'fontweight','normal','FontSize',36);
end
